.MODEL small
.STACK 100H 
.DATA
;----------------------------------------------------------------- 
Pirmas_failas   db 225 dup (0)
Antras_failas   db 225 dup (0)
handle1         dw ?
handle2         dw ?
simbolis        db ?
buff            db 225 dup ('$')  
;-----------------------------------------------------------------
nulis   db 'nulis$'
vienas  db 'vienas$'
du      db 'du$'
trys    db 'trys$'
keturi  db 'keturi$'
penki   db 'penki$'
sesi    db 'sesi$'
septyni db 'septyni$'
astuoni db 'astuoni$'
devyni  db 'devyni$'
;-----------------------------------------------------------------
 
.CODE 
START:
                                        
    mov ax, @data
    mov es, ax           ; es kad galetume naudot stosb funkcija
 
    lea di, Pirmas_failas
    mov si, 81h        ;programos paleidimo parametrai rasomi segmenta pradedant 129  baitu        
 
Ieskok:
    lodsb                                                          
    cmp   al, ' '
    je    Ieskok
    dec   si
    mov   ax, ds:[si]        ;i ax isirasom du baitus, i kuriuos rodo registras si
    jmp   Pirmas            ;uzciklinu 
 
Pirmas:
    lodsb
    cmp    al, ' '
    je     Kitas
    stosb                           ;perkelia simboli i es:di, di = di + 1
    jmp    Pirmas
 
Kitas:
    lodsb
    cmp    al, ' '
    je     Kitas
    lea    di, Antras_failas
    dec    si
 
Antras:
    lodsb
    cmp    al, 13
    je     Atidarom
    cmp    al, ' '
    je     Atidarom
    stosb                           ;Save character in file name
    jmp    Antras
 
;----------------------------------------------------------------- 
Atidarom: 
    mov ax, es
    mov ds, ax
 
    lea dx, Pirmas_failas    
    mov ah, 3dh                 ;atidaro faila
    mov al, 0                   ; 0 - reading, 1-writing, 2-abu
    int 21h
    mov handle1, ax                ; issaugojam filehandle
    jnc Rasymui                 ; jei cf = 0, viskas gerai, einam toliau
 
Rasymui:
    lea dx, Antras_failas    
    mov ah, 3dh                 ; atidaro faila
    mov al, 1                   ; al = 1, atidaro rasymui
    int 21h
    mov handle2, ax                ; file handle perkeliam i bx, nes reiks tolimesnese funkcijose
 
 
Skaitom:
    mov bx, handle1
    lea dx, buff         ; address of buff in dx
    mov cx, 20         ; kiek baitu nuskaitysim
    mov ah, 3fh         ; function 3Fh - read from file
    int 21h 
    mov cx, ax          
    cmp ax, 0
    je  Uzdarom
    lea si, buff
 
Atrenka:
    xor   ax, ax
    lodsb  
    push  cx
    call  taip
    call  print
    pop   cx
    loop  Atrenka
    jmp   Skaitom
 
 
Uzdarom:
    mov bx, handle1    
    mov ah, 3eh        
    int 21h
 
    mov bx, handle2
    int 21h

;-----------------------------------------------------------------

taip PROC  skaicius
    
    cmp al, '0'
    je  sk0
    cmp al, '1'
    je  sk1  
    cmp al, '2'
    je  sk2
    cmp al, '3'
    je  sk3  
    cmp al, '4'
    je  sk4
    cmp al, '5'
    je  sk5  
    cmp al, '6'
    je  sk6
    cmp al, '7'
    je  sk7
    cmp al, '8'
    je  sk8
    cmp al, '9'
    je  sk9  
    mov cx, 1
    mov simbolis, al
    lea dx, simbolis
    ret
 
sk0:
    lea dx, nulis
    mov cx,5       
    ret
sk1:
    lea dx, vienas
    mov cx, 6
    ret 
sk2:
    lea dx, du
    mov cx, 2
    ret
sk3:
    lea dx, trys
    mov cx, 4
    ret       
sk4:
    lea dx, keturi
    mov cx, 6
    ret
sk5:
    lea dx, penki
    mov cx, 5
    ret
sk6:
    lea dx, sesi
    mov cx, 4
    ret
sk7:
    lea dx, septyni
    mov cx, 7
    ret
sk8:
    lea dx, astuoni
    mov cx, 7
    ret
sk9:         
    lea dx, devyni
    mov cx, 6
    ret

;----------------------------------------------------------------- 
taip ENDP
 
print PROC skaicius
 
    mov bx, handle2
    mov ah, 40h
    int 21h
    ret 
 
print ENDP    
 
END START